﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
//using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DisplayControl
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        SerialPort displayPort = new SerialPort();
        Byte charPos = 0;

        private void btnOpenClosePort_Click(object sender, RoutedEventArgs e)
        {

            if (displayPort.IsOpen)
            {
                displayPort.Close();
                btnOpenClosePort.Content = "Otevřít port";
                gbDisplayData.IsEnabled = false;
            }
            else
            {
                try
                {
                    if (!cbComPorts.SelectedItem.Equals(Properties.Settings.Default.LastCOMport))
                    {
                        Properties.Settings.Default.LastCOMport = cbComPorts.SelectedItem.ToString();
                    }
                    displayPort.PortName = cbComPorts.SelectedItem.ToString();
                    displayPort.Open();
                    btnOpenClosePort.Content = "Zavřít port";

                    gbDisplayData.IsEnabled = true;
                }
                catch (Exception xx)
                {
                    MessageBox.Show(xx.Message);
                }
            }



            
        }

        void displayPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var avalilableComPorts = SerialPort.GetPortNames();

            foreach (var item in avalilableComPorts)
            {
                cbComPorts.Items.Add(item);
            }

            if (avalilableComPorts.Contains(Properties.Settings.Default.LastCOMport))
            {
                cbComPorts.SelectedItem = Properties.Settings.Default.LastCOMport;
            }

            if (avalilableComPorts.Length < 1)
            {
                btnOpenClosePort.IsEnabled = false;
            }

            displayPort.BaudRate = 19200;
            displayPort.StopBits = StopBits.One;
            displayPort.DataReceived += displayPort_DataReceived;
            
        }

        private void btnWriteData_Click(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i < tbText.Text.Length; i++)
            {
                byte[] data = new byte[] { 0x01, 0xA0, 0x0A, Encoding.ASCII.GetBytes(tbText.Text[i].ToString())[0], charPos, Convert.ToByte(cbTextColor.SelectedIndex + 1), 0x0D, 0x0D };

                displayPort.Write(data, 0, data.Length);
                charPos += 5;
                Thread.Sleep(20);
            }

        }

        private void btnDeleteDisplay_Click(object sender, RoutedEventArgs e)
        {
            tbText.Text = string.Empty;
            ClearDisplay();
            }


        private void ClearDisplay()
        {
            charPos = 0;
            for (int i = 0; i < 12; i++)
            {
                byte[] data = new byte[] { 0x01, 0xA0, 0x0A, 0x20, charPos, 0x05, 0x0D, 0x0D };

                displayPort.Write(data, 0, data.Length);
                charPos += 5;
                Thread.Sleep(25);
            }
            charPos = 0;
        }
    }
}
