﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
//using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DisplayTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        SerialPort serial = new SerialPort();
        Byte charPos = 0;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            serial.BaudRate = 19200;
            serial.StopBits = StopBits.One;
            serial.DataReceived += Serial_DataReceived;
         


        }

        private void Serial_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
        
        }


        private void btnOpenClosePort_Click(object sender, RoutedEventArgs e)
        {

            if (serial.IsOpen)
            {
                serial.Close();
                btnOpenClosePort.Content = "OPEN";
            }
            else
            {
                try
                {
                    btnOpenClosePort.Content = "CLOSE";
                    serial.PortName = tbComPort.Text;
                    serial.Open();
                }
                catch (Exception xx)
                {
                    if (!serial.IsOpen)
                    {
                        btnOpenClosePort.Content = "OPEN";
                    }
                    MessageBox.Show("Chyba: " + xx.Message);
                }
            
            }

            
        }


        private void ClearDisplay()
        {
            charPos = 0;


            for (int i = 0; i < 12; i++)
            {
                byte[] data = new byte[] { 0x01, 0xA0, 0x0A, 0x20, charPos, 0x05, 0x0D, 0x0D };

                serial.Write(data, 0, data.Length);
                charPos += 5;
                Thread.Sleep(10);
            }

            charPos = 0;
        }

        private void btnWriteTestData_Click(object sender, RoutedEventArgs e)
        {
            ClearDisplay();

            charPos = 0;
            string testString = "Test-ABcd123";
            int color = 0;


            for (int i = 0; i < testString.Length; i++)
            {
                byte[] data = new byte[] { 0x01, 0xA0, 0x0A, Encoding.ASCII.GetBytes(testString)[i], charPos, Convert.ToByte(color + 1), 0x0D, 0x0D };
                serial.Write(data, 0, data.Length);
                charPos += 5;
                color++;
                Thread.Sleep(10);
            }

        }
    }
}
